package com.perforce.bumble.connection;

import java.util.Properties;

import com.perforce.p4java.PropertyDefs;
import com.perforce.p4java.impl.mapbased.rpc.RpcPropertyDefs;
import com.perforce.p4java.server.IOptionsServer;
import com.perforce.p4java.server.ServerFactory;

public class ConnectionFactory {

	public static IOptionsServer getConnection(String uri) {
		Properties props = System.getProperties();

		// Identify ourselves in server log files.
		props.put(PropertyDefs.PROG_NAME_KEY, ConnectionConfig.getProduct());
		props.put(PropertyDefs.PROG_VERSION_KEY, ConnectionConfig.getVersion());

		// Set up socket pooling to use a single socket
		props.put(RpcPropertyDefs.RPC_SOCKET_POOL_SIZE_NICK, "0");

		// Allow p4 admin commands.
		props.put(RpcPropertyDefs.RPC_RELAX_CMD_NAME_CHECKS_NICK, "true");

		// disable timeout for slow servers / large db lock times
		props.put(RpcPropertyDefs.RPC_SOCKET_SO_TIMEOUT_NICK, "0");
		
		// Get a server connection
		IOptionsServer iserver = null;
		try {
			iserver = ServerFactory.getOptionsServer(uri, props);
		} catch (Exception e) {
			// return null
		}
		return iserver;
	}

}
